/***************************************************************************
 *   Copyright (C) 2005 by Rico Rommel   *
 *   ricorommel@web.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include "userdata.h"
#include <pwd.h>
#include <errno.h>
#include <stdlib.h>




_userdata *CreateUserData(char *configline, _userdata *UserData, int *count) {


	//alle benötigten Variablen
	char *username, *userdir, *timediffstr;
	int timediff = 0;

	struct passwd *user;

	char trenner[] = ":\n";
	username = strtok(configline, trenner);
	userdir = strtok(NULL, trenner);
	timediffstr = strtok(NULL, trenner);
	if (timediffstr != NULL) timediff = strtol(timediffstr, NULL, 10);

		user = getpwnam( username );
			
		if (user != 0){ //Wenn Benutzer existiert alles in UID UNd Verzeichnis in UserData ablegen

			UserData = realloc(UserData, (*count+1)*sizeof(_userdata));
			(UserData+(*count))->userid = user->pw_uid;
			(UserData+(*count))->dirname = strdup(userdir);
			(UserData+(*count))->timediff = timediff;
			(*count)++;
		}

		else fprintf(output, "Warnung : Benutzer %s nicht bekannt\n", username);

	return UserData;

}


_userdata *CreateUserDataFromCommandline(int argc, char *argv[], int start, int *count) {

	/*Erzeigt die Struktur UserData von der Kommandozeile
	Parameter 	argc:	Anzahl der übergeben Parameter
			argv:	Parameter
			start:	erster Paramter, der uns interessiert
			count:	Anzahl der Datensätzre in Usercount*/
	_userdata *UserData = NULL;

	while ( (start < argc) ) {


		if (argv[start][0] == 45) return UserData;
		UserData = CreateUserData(argv[start], UserData, count);
		start++;
	}
	return UserData;
}
